function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { forwardRef, useContext, useImperativeHandle, useRef, useCallback } from 'react';
import { Empty, Spin } from 'antd';
import useStyle from "./styles/index";
import classNames from "classnames";
import { FanContext } from "../ConfigContext";
import { DndContext } from '@dnd-kit/core';
import { arrayMove, SortableContext, verticalListSortingStrategy } from '@dnd-kit/sortable';
// import { CSS } from '@dnd-kit/utilities';
import { restrictToParentElement } from '@dnd-kit/modifiers';
// @dnd-kit 文档 https://docs.dndkit.com/presets/sortable/usesortable
// @dnd-kit 示例 https://master--5fc05e08a4a65d0021ae0bf2.chromatic.com/?path=/story/core-draggable-hooks-usedraggable--basic-setup
// 参考：https://juejin.cn/post/7265729258122281017
import SortableItem from "./SortableItem";
// index获取算法，事件的回调包含active和over对象，无法直接用indexOf获取在原数组中的index
// 用这个方法遍历获取在原数组对应的位置index，供arrayMove方法使用
var getMoveIndex = function getMoveIndex(array, dragItem, optionName) {
  var active = dragItem.active,
    over = dragItem.over;
  var activeIndex = 0;
  var overIndex = 0;
  try {
    // 遍历数组，查找出active和over的index
    array.forEach(function (item, index) {
      if (active[optionName.value || 'value'] === item[optionName.value || 'value']) {
        activeIndex = index;
      }
      if (over[optionName.value || 'value'] === item[optionName.value || 'value']) {
        overIndex = index;
      }
    });
  } catch (error) {
    overIndex = activeIndex; // 如果有问题，则复位
  }
  return {
    activeIndex: activeIndex,
    overIndex: overIndex
  };
};
var StandardList = /*#__PURE__*/forwardRef(function (props, ref) {
  var InitFanContext = useContext(FanContext);
  var providerConfig = InitFanContext['StandardList'] || {}; // 使用上下文（全局配置）设置扩展的配置项
  // const proLayoutProps = InitFanContext['proLayoutProps'] || {}
  var componentName = 'spec-standard-list';
  var _useStyle = useStyle(componentName),
    _useStyle2 = _slicedToArray(_useStyle, 2),
    wrapSSR = _useStyle2[0],
    hashId = _useStyle2[1];
  var _providerConfig$props = _objectSpread(_objectSpread({}, providerConfig), props),
    className = _providerConfig$props.className,
    style = _providerConfig$props.style,
    _providerConfig$props2 = _providerConfig$props.options,
    options = _providerConfig$props2 === void 0 ? [] : _providerConfig$props2,
    _providerConfig$props3 = _providerConfig$props.optionName,
    optionName = _providerConfig$props3 === void 0 ? {
      value: 'value',
      label: 'label',
      disabled: 'disabled'
    } : _providerConfig$props3,
    footer = _providerConfig$props.footer,
    fullHeight = _providerConfig$props.fullHeight,
    emptyDescription = _providerConfig$props.emptyDescription,
    onSelect = _providerConfig$props.onSelect,
    selectedKeys = _providerConfig$props.selectedKeys,
    multiple = _providerConfig$props.multiple,
    checkable = _providerConfig$props.checkable,
    _providerConfig$props4 = _providerConfig$props.loading,
    loading = _providerConfig$props4 === void 0 ? false : _providerConfig$props4,
    sortable = _providerConfig$props.sortable,
    onChange = _providerConfig$props.onChange;
  var contentRef = useRef();
  useImperativeHandle(ref, function () {
    return contentRef === null || contentRef === void 0 ? void 0 : contentRef.current;
  });
  // 是否显示提示框
  var handleClick = useCallback(function (item) {
    var prevSelect = _toConsumableArray(selectedKeys || []);
    var matchIndex = prevSelect.findIndex(function (sItem) {
      return sItem === item[optionName === null || optionName === void 0 ? void 0 : optionName.value] || sItem === (item === null || item === void 0 ? void 0 : item.value);
    });
    if (matchIndex !== -1) {
      prevSelect.splice(matchIndex, 1);
    } else {
      if (multiple) {
        prevSelect.push(item[optionName === null || optionName === void 0 ? void 0 : optionName.value] || (item === null || item === void 0 ? void 0 : item.value));
      } else {
        prevSelect = [item[optionName === null || optionName === void 0 ? void 0 : optionName.value] || (item === null || item === void 0 ? void 0 : item.value)];
      }
    }
    onSelect === null || onSelect === void 0 || onSelect(prevSelect, item, {
      selected: !(matchIndex !== -1),
      checked: multiple ? matchIndex !== -1 : false,
      currentData: _objectSpread(_objectSpread({}, item), {}, {
        selected: !(matchIndex !== -1),
        checked: multiple ? matchIndex !== -1 : false
      }),
      multiData: (options || []).filter(function (item) {
        return prevSelect.includes(item[optionName === null || optionName === void 0 ? void 0 : optionName.value] || (item === null || item === void 0 ? void 0 : item.value));
      })
    });
  }, [selectedKeys, options, multiple, checkable]);

  // 拖拽结束后的操作
  var dragEndEvent = function dragEndEvent(event) {
    var moveDataList = _toConsumableArray(options || []);
    var _getMoveIndex = getMoveIndex(moveDataList, event, optionName),
      activeIndex = _getMoveIndex.activeIndex,
      overIndex = _getMoveIndex.overIndex;
    var sortedOptions = arrayMove(moveDataList, activeIndex, overIndex);
    onChange === null || onChange === void 0 || onChange(sortedOptions, event);
  };
  // useEffect(() => {
  //   props?.onChange(dataList);// 这里写你自己对父组件传值的方式
  // }, []);

  return wrapSSR( /*#__PURE__*/React.createElement("div", {
    className: classNames(componentName, className, hashId, fullHeight ? 'spec-standard-list-fullheight' : ''),
    style: style,
    ref: contentRef
  }, /*#__PURE__*/React.createElement(Spin, {
    spinning: loading,
    wrapperClassName: 'spec-standard-list-loading'
  }, sortable // 开启排序
  ? /*#__PURE__*/React.createElement(DndContext, {
    onDragEnd: dragEndEvent,
    modifiers: [restrictToParentElement] // 拖动范围只能是父节点下区域
  }, /*#__PURE__*/React.createElement(SortableContext, {
    items: options.map(function (c) {
      return c[optionName === null || optionName === void 0 ? void 0 : optionName.value];
    }),
    strategy: verticalListSortingStrategy
  }, /*#__PURE__*/React.createElement("div", {
    className: 'spec-standard-list-selections'
  }, !options || options.length === 0 ? /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: emptyDescription
  }) : (options || []).map(function (item, index) {
    return /*#__PURE__*/React.createElement(SortableItem, {
      key: item[optionName === null || optionName === void 0 ? void 0 : optionName.value] || index,
      item: item,
      itemIndex: index,
      onClick: handleClick,
      parentProps: props
    });
  })))) : /*#__PURE__*/React.createElement("div", {
    className: 'spec-standard-list-selections'
  }, !options || options.length === 0 ? /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: emptyDescription
  }) : (options || []).map(function (item, index) {
    return /*#__PURE__*/React.createElement(SortableItem, {
      key: item[optionName === null || optionName === void 0 ? void 0 : optionName.value] || index,
      item: item,
      itemIndex: index,
      onClick: handleClick,
      parentProps: props
    });
  })), footer && /*#__PURE__*/React.createElement("div", {
    className: 'spec-standard-list-footer'
  }, footer))));
});
export default StandardList;